# -*- coding: utf-8 -*-
#
# dFlash Plugin by gutemine
#
dflash_version="3.2"
#
from Components.ActionMap import ActionMap
from Components.Label import Label
from Components.config import config, ConfigSubsection, ConfigText, ConfigBoolean, ConfigInteger, ConfigSelection, getConfigListEntry
from Components.ConfigList import ConfigListScreen
from Plugins.Plugin import PluginDescriptor
from Components.Pixmap import Pixmap
from Screens.Screen import Screen
from Screens.MessageBox import MessageBox 
from Screens.InputBox import InputBox
from Components.Input import Input
from Screens.ChoiceBox import ChoiceBox
from Components.AVSwitch import AVSwitch
from Components.SystemInfo import SystemInfo
from Screens.Console import Console                                                                           
from Components.MenuList import MenuList       
from enigma import eConsoleAppContainer, eDVBVolumecontrol, eTimer
from Tools.LoadPixmap import LoadPixmap
import Screens.Standby  
import sys, os, struct, stat, time
from os import statvfs, path as os_path, chmod as os_chmod, write as os_write, open as os_open,\
		close as os_close, unlink as os_unlink
from twisted.web import resource, http
import gettext, datetime

dflash_plugindir="/usr/lib/enigma2/python/Plugins/Extensions/dFlash" 
dflash_pluginlink="/tmp/dFlash" 
dflash_bin="%s/bin" % dflash_pluginlink
dflash_busy="/tmp/.dflash"
dflash_script="/tmp/dflash.sh"
dflash_backup="/tmp/.dbackup"
dflash_backupscript="/tmp/dbackup.sh"
dflash_backuplog="/tmp/dbackup.log"

if not os.path.exists(dflash_pluginlink):
	os.symlink(dflash_plugindir,dflash_pluginlink)
# add local language file
dflash_sp=config.osd.language.value.split("_")
dflash_language = dflash_sp[0]
if os.path.exists("%s/locale/%s" % (dflash_plugindir,dflash_language)):
	_=gettext.Catalog('dflash', '%s/locale' % dflash_plugindir,dflash_sp).gettext

boxtype="dm7025"
if os.path.exists("/proc/stb/info/model"):
	f=open("/proc/stb/info/model")
	boxtype=f.read()
	f.close()
	boxtype=boxtype.replace("\n","").replace("\l","")

yes_no_descriptions = {False: _("no"), True: _("yes")}    

config.plugins.dflash = ConfigSubsection()
config.plugins.dflash.backuplocation = ConfigText(default = "/media/hdd/backup", fixed_size=False, visible_width=40)
config.plugins.dflash.sort = ConfigBoolean(default = True, descriptions=yes_no_descriptions)
config.plugins.dflash.keep = ConfigBoolean(default = False, descriptions=yes_no_descriptions)
config.plugins.dflash.restart = ConfigBoolean(default = False, descriptions=yes_no_descriptions)
config.plugins.dflash.loopswap = ConfigBoolean(default = False, descriptions=yes_no_descriptions)
config.plugins.dflash.synchronous = ConfigBoolean(default = False, descriptions=yes_no_descriptions)
config.plugins.dflash.swapsize = ConfigInteger(default = 128, limits = (128, 2048))
config.plugins.dflash.ramfs = ConfigBoolean(default = False, descriptions=yes_no_descriptions)
config.plugins.dflash.usr = ConfigBoolean(default = False, descriptions=yes_no_descriptions)
config.plugins.dflash.summary = ConfigBoolean(default = True, descriptions=yes_no_descriptions)
if boxtype != "dm8000" and boxtype != "dm7020hd":
	config.plugins.dflash.summary.value = False
config.plugins.dflash.extension = ConfigBoolean(default = False, descriptions=yes_no_descriptions)
#config.plugins.dflash.flashtool = ConfigSelection(default = "nfidump", choices = [("nfidump", _("nfidump")), ("writenfi", _("writenfi")), ("nandwrite", _("nandwrite"))])
config.plugins.dflash.flashtool = ConfigSelection(default = "writenfi", choices = [("nfidump", _("nfidump")), ("writenfi", _("writenfi"))])
config.plugins.dflash.overwrite = ConfigBoolean(default = False, descriptions=yes_no_descriptions)

fileupload_string=_("Select nfi image for flashing")
disclaimer_header=_("Disclaimer")
disclaimer_string=_("This way of flashing your Dreambox is potentially\ndangerous and not supported in any way from DMM.\n\nYou are using it completely at you own risk!\nIf you want to flash your Dreambox safely use the Webinterface or DreamUP!\n\nMay the Null modem cable be with you!")
disclaimer_wstring=disclaimer_string.replace("\n","<br>")
plugin_string=_("direct Flash Plugin by gutemine Version %s") % dflash_version
waiting_string=_("%i MB Swapspace OK") % config.plugins.dflash.swapsize.value
flashing_string=_("Flashing") 
backup_string=_("Backup") 
setup_string=_("Configuring")
checking_string=_("Checking")
running_string=_("Backup is running...")
backupimage_string=_("Enter Backup Imagename")
backupdirectory_string=_("Enter Backup Path")
unsupported_string=_("Sorry, currently not supported on this Dreambox type")
nonfi_string=_("Sorry, no correct nfi file selected")
badblocks_string=_("Sorry, bad blocks in %s Flash, better try DreamUP with recover bad sectors")
refresh_string=_("Refresh")
mounted_string=_("Nothing mounted at %s")

header_string  =""
header_string +="<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\""
header_string +="\"http://www.w3.org/TR/html4/loose.dtd\">"
header_string +="<head><title>%s</title>" % plugin_string
header_string +="<link rel=\"shortcut icon\" type=\"/web-data/image/x-icon\" href=\"/web-data/img/favicon.ico\">"
header_string +="<meta content=\"text/html; charset=UTF-8\" http-equiv=\"content-type\">"
header_string +="</head><body bgcolor=\"black\">"
header_string +="<font face=\"Tahoma, Arial, Helvetica\" color=\"yellow\">"
header_string +="<font size=\"3\" color=\"yellow\">"

dflash_backbutton=_("use back button in browser and try again!") 
dflash_flashing=""
dflash_flashing += header_string
dflash_flashing += "<br>%s ...<br><br>" % flashing_string
dflash_flashing +="<br><img src=\"/web-data/img/dflash.png\" alt=\"%s ...\"/><br><br>" % (flashing_string)

dflash_backuping  =""
dflash_backuping += header_string
dflash_backuping += "<br>%s<br><br>" % running_string
dflash_backuping +="<br><img src=\"/web-data/img/ring.png\" alt=\"%s ...\"/><br><br>" % (backup_string)
dflash_backuping +="<form method=\"GET\">"
dflash_backuping +="<input name=\"command\" type=\"submit\" size=\"100px\" title=\"%s\" value=\"%s\">" % (refresh_string,"Refresh")
dflash_backuping +="</form>"                        

class dFlash(Screen):
	skin = """
		<screen position="center,60" size="640,60" title="Flashing" >
		<widget name="logo" position="10,10" size="100,40" transparent="1" alphatest="on" />
		<widget name="buttonred" position="120,10" size="120,40" backgroundColor="red" valign="center" halign="center" zPosition="2"  foregroundColor="white" font="Regular;18"/>
		<widget name="buttongreen" position="250,10" size="120,40" backgroundColor="green" valign="center" halign="center" zPosition="2"  foregroundColor="white" font="Regular;18"/>
		<widget name="buttonyellow" position="380,10" size="120,40" backgroundColor="yellow" valign="center" halign="center" zPosition="2"  foregroundColor="white" font="Regular;18"/>
		<widget name="buttonblue" position="510,10" size="120,40" backgroundColor="blue" valign="center" halign="center" zPosition="2"  foregroundColor="white" font="Regular;18"/>
	</screen>"""
	def __init__(self, session, args = 0):
		Screen.__init__(self, session)
		self.onShown.append(self.setWindowTitle)      
                self.onLayoutFinish.append(self.byLayoutEnd)
		self["logo"] = Pixmap()
		self["buttonred"] = Label(_("Cancel"))
		self["buttongreen"] = Label(_("Backup"))
		self["buttonyellow"] = Label(_("Flashing"))
		self["buttonblue"] = Label(setup_string)
		self["setupActions"] = ActionMap([ "ColorActions", "SetupActions" ],
			{
			"green": self.backup,
			"red": self.leaving,
			"blue": self.config,
			"yellow": self.flash,
			"save": self.leaving,
			"cancel": self.leaving,
			})

	def setWindowTitle(self):
		if os.path.exists(dflash_busy):                                                                   
       			self["logo"].instance.setPixmapFromFile("%s/ring.png" % dflash_plugindir)
		else:                                                                            
       			self["logo"].instance.setPixmapFromFile("%s/dflash.png" % dflash_plugindir)
		self.setTitle(flashing_string+" & "+backup_string+" V%s" % dflash_version)

        def byLayoutEnd(self):
                self["logo"].instance.setPixmapFromFile("%s/dflash.png" % dflash_plugindir)

	def leaving(self):
	        if os.path.exists(dflash_busy):
			self.session.open(MessageBox, running_string, MessageBox.TYPE_ERROR)
		else:
			self.close()

        def checking(self):      
                self.session.open(dFlashChecking)

	def flash(self):
	        if os.path.exists(dflash_busy):
			self.session.open(MessageBox, running_string, MessageBox.TYPE_ERROR)
		else:
			if os.path.exists("/proc/stb/info/model"):
  				f=open("/proc/stb/info/model")
  				self.boxtype=f.read()
  				f.close()
  				self.boxtype=self.boxtype.replace("\n","").replace("\l","")
			else:
  				f=open("/proc/bus/dreambox")
  				content=f.read()
  				f.close()
				if content.find("7020") is not -1:
  					self.boxtype="dm7020"
				if content.find("600PVR") is not -1:
  					self.boxtype="dm600pvr"
				if content.find("500PLUS") is not -1:
  					self.boxtype="dm500plus"
			if self.boxtype == "dm7025" or self.boxtype == "dm7020" or self.boxtype == "dm500plus":
				self.session.open(MessageBox, unsupported_string, MessageBox.TYPE_ERROR)
			else:
       				self.session.openWithCallback(self.askForImage,ChoiceBox,fileupload_string,self.getImageList())

	def askForImage(self,image):
        	if image is None:
			self.session.open(MessageBox, nonfi_string, MessageBox.TYPE_ERROR)
        	else:
			self.nfifile=image[1]
			nfisize=os.path.getsize(self.nfifile)	
 			print "[dFlash] nfi file size %i" % nfisize
 			f = open(self.nfifile,"r")
 			header = f.read(32)     
  			f.close()
       			machine_type = header[4:4+header[4:].find("\0")]                        
			if os.path.exists("/proc/stb/info/model"):
				b=open("/proc/stb/info/model","r")
				dreambox=b.read().rstrip("\n")
				b.close()
			else:
  				f=open("/proc/bus/dreambox")
  				content=f.read()
  				f.close()
				if content.find("7020") is not -1:
  					dreambox="dm7020"
				if content.find("600PVR") is not -1:
  					dreambox="dm600pvr"
				if content.find("500PLUS") is not -1:
  					dreambox="dm500plus"
 			v = open("/usr/lib/opkg/status","r")
 			line = v.readline()     
			found=False
			loaderversion=0
			while (line) and not found:                                                                   
                        	line = v.readline()                                                
                        	if line.startswith("Package: dreambox-secondstage"):                                            
                                	found=True                                                  
	                        	line = v.readline()                                                
                                        line=line.replace("Version: ","")
					loader=line.split("-")
					loaderversion=int(loader[0])
  			v.close()
			print "[dFlash] %s %s %i %s" % (machine_type,dreambox,loaderversion,header[:4])
			if machine_type.startswith(dreambox) is False and dreambox is not "dm7020":                                        
				print "[dFlash] wrong header"
				self.session.open(MessageBox, nonfi_string, MessageBox.TYPE_ERROR)
			elif (dreambox == "dm800" or dreambox == "dm800se" or dreambox == "dm500hd" or dreambox == "dm7020hd") and loaderversion < 84 and header[:4] == "NFI2":
				print "[dFlash] wrong header"
				self.session.open(MessageBox, nonfi_string, MessageBox.TYPE_ERROR)
			elif (dreambox == "dm800" or dreambox == "dm800se" or dreambox == "dm500hd" or dreambox == "dm7020hd") and loaderversion >= 84 and header[:4] != "NFI2":
				print "[dFlash] wrong header"
				self.session.open(MessageBox, nonfi_string, MessageBox.TYPE_ERROR)
			elif (dreambox == "dm7025" or dreambox == "dm8000") and header[:4] != "NFI1":
				print "[dFlash] wrong header"
				self.session.open(MessageBox, nonfi_string, MessageBox.TYPE_ERROR)
			else:
				loaderdev="/dev/mtd/1"
				if os.path.exists("/dev/mtd1"):
					loaderdev="/dev/mtd1"
				os.system("%s/bin/nand_check %s > /tmp/.nandcheck" % (dflash_plugindir,loaderdev))
				f=open("/tmp/.nandcheck")
				bad=0
		                for line in f.readlines():
					if line.startswith("="):
						print line
						if line.find("B") is not -1:
							bad=1
				f.close()
				if bad:
					self.session.open(MessageBox, badblocks_string % loaderdev, MessageBox.TYPE_ERROR)
				else:
               				self.session.openWithCallback(self.startFlash,MessageBox,_("Are you sure that you want to flash now %s ?") %(self.nfifile), MessageBox.TYPE_YESNO)

        def getImageList(self):                                               
        	list = []                                                        
        	for name in os.listdir("/tmp"):                          
			if name.endswith(".nfi"):
        	       		list.append(( name.replace(".nfi",""), "/tmp/%s" % name ))                         
				if config.plugins.dflash.sort.value:
					list.sort()
				return list
		if not config.plugins.dflash.backuplocation.value.startswith("/media/net") or config.plugins.dflash.ramfs.value:
			if os.path.exists(config.plugins.dflash.backuplocation.value):
           			for name in os.listdir(config.plugins.dflash.backuplocation.value):                          
					if name.endswith(".nfi"):
                 				list.append(( name.replace(".nfi",""), "%s/%s" % (config.plugins.dflash.backuplocation.value,name)))                         
           	for directory in os.listdir("/media"):                          
			if os.path.exists("/media/%s" % directory) and os.path.isdir("/media/%s" % directory) and directory.endswith("net") is False and directory.endswith("hdd") is False:
           			for name in os.listdir("/media/%s" % directory):                          
					if name.endswith(".nfi"):
                 				list.append(( name.replace(".nfi",""), "/media/%s/%s" % (directory,name) ))                         
		if config.plugins.dflash.sort.value:
			list.sort()
        	return list                                                

	def startFlash(self,option):
        	if option is False:
			self.session.open(MessageBox, _("Sorry, Flashing of %s was canceled!") % self.nfifile, MessageBox.TYPE_ERROR)
        	else:
			CreateScript()
			self.session.openWithCallback(self.doFlash, MessageBox, _("Press OK now for flashing\n\n%s\n\nBox will reboot automatically when finished!") % self.nfifile, MessageBox.TYPE_INFO)

	def doFlash(self,option):
		if option:
			print "[dFlash] is flashing now %s" % self.nfifile
			if (eDVBVolumecontrol.getInstance().isMuted()) is False:
				eDVBVolumecontrol.getInstance().volumeToggleMute()
			self.avswitch = AVSwitch()
			if SystemInfo["ScartSwitch"]:
				self.avswitch.setInput("SCART")
			else:
				self.avswitch.setInput("AUX")
			print "[dFlash] is flashing now %s" % self.nfifile
       			os.system("start-stop-daemon -S -b -x %s \"%s\"" % (dflash_script,self.nfifile))
 		        self.FlashTimer = eTimer()
       		 	self.FlashTimer.stop()
         		self.FlashTimer.timeout.get().append(self.secondFlash)
         		self.FlashTimer.start(60000,True)
		else:
			print "[dFlash] cancelled flashing %s" % self.nfifile

	def secondFlash(self):
		print "[dFlash] second flashing now %s" % self.nfifile
 		os.system("%s \"%s\" &" % (dflash_script,self.nfifile))
     	 	self.FlashTimer.stop()

	def cancel(self):
		self.close(False)

	def backup(self):
		if os.path.exists(dflash_backupscript):
			os.remove(dflash_backupscript)
		if os.path.exists(dflash_backup):
			f=open(dflash_backup)
    			line=f.readline()
    			f.close()
			os.remove(dflash_backup)
			sp=[]
			sp=line.split("	")
			print sp
			length=len(sp)
			size=""
			image=""
			path=""
			if length > 0:
				size=sp[0].rstrip().lstrip()
				sp2=[]
				sp2=sp[length-1].split("/")
				print sp2
				length=len(sp2)
				if length > 0:
					image=sp2[length-1]
					path=line.replace(size,"").replace(image,"")
					image=image.replace(".nfi\n","")
					image=image.rstrip().lstrip()
			print "[dFlash] found backup %s" % line
      			self.session.open(MessageBox,size+"B "+_("Flash Backup to %s finished with imagename:\n\n%s.nfi") % (path,image),  MessageBox.TYPE_INFO)                 
		else:
	        	if os.path.exists(dflash_busy):
				self.session.open(MessageBox, running_string, MessageBox.TYPE_ERROR)
			else:
                		self.session.openWithCallback(self.askForBackupPath,InputBox, title=backupdirectory_string, text="%s                       " % config.plugins.dflash.backuplocation.value, maxSize=40, type=Input.TEXT)

        def askForBackupPath(self,path):
           	if path is None:
              		self.session.open(MessageBox,_("nothing entered"),  MessageBox.TYPE_ERROR)                 
           	else:
			sp=[]
			sp=path.split("/")
			print sp
			if len(sp) > 1:
				if sp[1] != "media":
 	             			self.session.open(MessageBox,mounted_string % path,  MessageBox.TYPE_ERROR)                 
					return
			mounted=False
			self.swappable=False
			sp2=[]
                	f=open("/proc/mounts", "r")
       		 	m = f.readline()                                                    
        		while (m) and not mounted:                                             
				if m.find("/%s/%s" % (sp[1],sp[2])) is not -1:
					mounted=True
					print m
					sp2=m.split(" ")
					print sp2
					if sp2[2].startswith("ext") or sp2[2].endswith("fat"):
						print "[dFlash] swappable"
						self.swappable=True
           			m = f.readline()                                                 
			f.close()	
			if not mounted:
 	             		self.session.open(MessageBox,mounted_string % path,  MessageBox.TYPE_ERROR)                 
				return
			path=path.lstrip().rstrip().replace(" ","")
	      		config.plugins.dflash.backuplocation.value=path
	      		config.plugins.dflash.backuplocation.save()
		        if not os.path.exists(config.plugins.dflash.backuplocation.value):
		 		os.mkdir(config.plugins.dflash.backuplocation.value,0777)
			if os.path.exists("/proc/stb/info/model"):
  				f=open("/proc/stb/info/model")
  				self.boxtype=f.read()
  				f.close()
  				self.boxtype=self.boxtype.replace("\n","").replace("\l","")
			else:
  				f=open("/proc/bus/dreambox")
  				content=f.read()
  				f.close()
				if content.find("7020") is not -1:
  					self.boxtype="dm7020"
				if content.find("600PVR") is not -1:
  					self.boxtype="dm600pvr"
				if content.find("500PLUS") is not -1:
  					self.boxtype="dm500plus"
			name="OpenEmbedded"
			if os.path.exists("/etc/image-version"):
				f=open("/etc/image-version")
	 			line = f.readline()                                                    
        			while (line):                                             
        				line = f.readline()                                                 
        				if line.startswith("creator="):                                    
						name=line
        			f.close()                                                              
				name=name.replace("creator=","")
				sp=[]
				if len(name) > 0:
					sp=name.split(" ")
					if len(sp) > 0:
						name=sp[0]
						name=name.replace("\n","")
			self.creator=name.rstrip().lstrip()
			self.imagetype="exp"
			if name == "OoZooN" and os.path.exists("/etc/issue.net"):
				f=open("/etc/issue.net")
				i=f.read()
				f.close()
				if i.find("xperimental") is -1:
					self.imagetype="rel"
			name=name+"-"+self.imagetype
                	self.session.openWithCallback(self.askForBackupName,InputBox, title=backupimage_string, text="%s-%s-%s-%s                        " % (name,self.boxtype,datetime.date.today(),time.strftime("%H-%M")), maxSize=40, type=Input.TEXT)

        def askForBackupName(self,name):
           if name is None:
              self.session.open(MessageBox,_("nothing entered"),  MessageBox.TYPE_ERROR)                 
           else:
	      self.backupname=name.replace(" ","").replace("[","").replace("]","").replace(">","").replace("<","").replace("|","").rstrip().lstrip()
      	      if os.path.exists("%s/%s.nfi" % (config.plugins.dflash.backuplocation.value,self.backupname)):
               		self.session.openWithCallback(self.confirmedBackup,MessageBox,"%s.nfi" % self.backupname +"\n"+_("already exists,")+" "+_("overwrite ?"), MessageBox.TYPE_YESNO)
	      else:
			self.confirmedBackup(True)

        def confirmedBackup(self,answer):
	      if answer is True:
	      	 if os.path.exists("%s/%s.nfi" % (config.plugins.dflash.backuplocation.value,self.backupname)):
	      		os.remove("%s/%s.nfi" % (config.plugins.dflash.backuplocation.value,self.backupname))
	      	 if os.path.exists("%s/%s.nfo" % (config.plugins.dflash.backuplocation.value,self.backupname)):
	      		os.remove("%s/%s.nfo" % (config.plugins.dflash.backuplocation.value,self.backupname))
	      	 # check if swapfile too small
	         fm=open("/proc/meminfo")                                                
       	         line = fm.readline()                                                    
       	         swapspace=0                                                                  
                 while (line):                                             
           	    line = fm.readline()                                                 
           	    if line.startswith("SwapTotal:"):                                    
              		swapspace=int(line.replace("SwapTotal: ","").replace("kB",""))/1000             
                 fm.close()                                                              
	         print "[dFlash] swapspace: %i MB" % swapspace
		 self.ownswap=False
	         if swapspace < config.plugins.dflash.swapsize.value: 
			if self.swappable or config.plugins.dflash.loopswap.value:
		 		action_string=_("\n\nUsing temporary swapspace.")
		 	else:
		 		action_string=_("\n\nEnigma2 will restart due to lack of swapspace,\ncheck result with Backup in Plugin afterwards.")
		 else:
		 	action_string=_("\n\nUsing existing swapspace.")
			self.ownswap=True
                 self.session.openWithCallback(self.startBackup,MessageBox, _("Press OK for starting backup to\n\n%s.nfi\n\nBe patient, this takes 3-5min ... ") % self.backupname + action_string, MessageBox.TYPE_INFO)
	      else:
              	 self.session.open(MessageBox,_("not confirmed"),  MessageBox.TYPE_ERROR)                 
		
        def startBackup(self,answer):
	      print "[dFlash] is backuping now ..."
              self["logo"].instance.setPixmapFromFile("%s/ring.png" % dflash_plugindir)
	      BackupImage(self.session,self.backupname,self.imagetype,self.creator,self.swappable,self.ownswap)

	def config(self):
        	self.session.open(dFlashConfiguration)

def startdFlash(session, **kwargs):
       	session.open(dFlash)   

def autostart(reason,**kwargs):
        if kwargs.has_key("session") and reason == 0:           
		session = kwargs["session"]                       
		print "[dFlash] autostart"
		if os.path.exists(dflash_busy):
			os.remove(dflash_busy)

def sessionstart(reason, **kwargs):                                               
        if reason == 0 and "session" in kwargs:                                                        
		if os.path.exists("/usr/lib/enigma2/python/Plugins/Extensions/WebInterface/WebChilds/Toplevel.py"):
                        from Plugins.Extensions.WebInterface.WebChilds.Toplevel import addExternalChild
                        addExternalChild( ("dflash", wFlash(), "dFlash", "1", True) )          
                else:                                                                                  
			print "[dFLASH] Webif not found"

def Plugins(**kwargs):
	if os.path.exists("/usr/lib/enigma2/python/Plugins/Bp/geminimain") or config.plugins.dflash.extension.value:
		return [PluginDescriptor(where = [PluginDescriptor.WHERE_SESSIONSTART, PluginDescriptor.WHERE_AUTOSTART], fnc = autostart),
			PluginDescriptor(name=flashing_string, description=flashing_string+" & "+backup_string, where=PluginDescriptor.WHERE_MENU, fnc=mainconf),
			PluginDescriptor(name="dFlash", description=flashing_string+" & "+backup_string, where = PluginDescriptor.WHERE_EXTENSIONSMENU, icon="g3icon_dflash.png", fnc=startdFlash),
            		PluginDescriptor(where=PluginDescriptor.WHERE_SESSIONSTART, fnc=sessionstart, needsRestart=False)]
	else:
		return [PluginDescriptor(where = [PluginDescriptor.WHERE_SESSIONSTART, PluginDescriptor.WHERE_AUTOSTART], fnc = autostart),
			PluginDescriptor(name=flashing_string, description=flashing_string+" & "+backup_string, where=PluginDescriptor.WHERE_MENU, fnc=mainconf),
            		PluginDescriptor(where=PluginDescriptor.WHERE_SESSIONSTART, fnc=sessionstart, needsRestart=False)]

def mainconf(menuid):
    if menuid != "setup":                                                  
        return [ ]                                                     
    return [(flashing_string+" & "+backup_string, startdFlash, "dflash", None)]    

###############################################################################
# dFlash Webinterface by gutemine
###############################################################################

class wFlash(resource.Resource):

	def render_GET(self, req):
		file = req.args.get("file",None)
		directory = req.args.get("directory",None)
		command = req.args.get("command",None)
		print "[dFlash] received %s %s %s" % (command,directory,file)
		req.setResponseCode(http.OK)
		req.setHeader('Content-type', 'text/html')
                req.setHeader('charset', 'UTF-8')
		if os.path.exists("/usr/lib/enigma2/python/Plugins/Extensions/WebInterface/web-data/img/dflash.png") is False:
			os.symlink("%s/dflash.png" % dflash_plugindir,"/usr/lib/enigma2/python/Plugins/Extensions/WebInterface/web-data/img/dflash.png")
		if os.path.exists("/usr/lib/enigma2/python/Plugins/Extensions/WebInterface/web-data/img/ring.png") is False:
			os.symlink("%s/ring.png" % dflash_plugindir,"/usr/lib/enigma2/python/Plugins/Extensions/WebInterface/web-data/img/ring.png")
		if os.path.exists(dflash_busy):
			return header_string+dflash_backuping
		if command is None or command[0] == "Refresh":
		        fm=open("/proc/meminfo")                                                
       		 	line = fm.readline()                                                    
       		 	swapspace=0                                                                  
			line=True
        		while (line):                                             
           			line = fm.readline()                                                 
           			if line.startswith("SwapTotal:"):                                    
              				swapspace=int(line.replace("SwapTotal: ","").replace("kB",""))/1000             
        		fm.close()                                                              
			if os.path.exists("/proc/stb/info/model"):
				b=open("/proc/stb/info/model","r")
				dreambox=b.read().rstrip("\n")
				b.close()
			else:
  				b=open("/proc/bus/dreambox")
  				content=b.read()
  				b.close()
				if content.find("7020") is not -1:
  					dreambox="dm7020"
				if content.find("600PVR") is not -1:
  					dreambox="dm600pvr"
				if content.find("500PLUS") is not -1:
  					dreambox="dm500plus"

			htmlnfi=""
	 		for name in os.listdir("/tmp"):                          
				if name.endswith(".nfi"):
       			       		name=name.replace(".nfi","")                        
					htmlnfi += "<option value=\"/tmp/%s.nfi\" class=\"black\">%s</option>\n" % (name,name)
			if not config.plugins.dflash.backuplocation.value.startswith("/media/net") or config.plugins.dflash.ramfs.value:
				if os.path.exists(config.plugins.dflash.backuplocation.value):
       					for name in os.listdir(config.plugins.dflash.backuplocation.value):                          
						if name.endswith(".nfi"):
       	 	      					name=name.replace(".nfi","")                        
							htmlnfi += "<option value=\"%s/%s.nfi\" class=\"black\">%s</option>\n" % (config.plugins.dflash.backuplocation.value,name,name)
       			for directory in os.listdir("/media"):                          
				if os.path.exists("/media/%s" % directory) and os.path.isdir("/media/%s" % directory) and directory.endswith("net") is False and directory.endswith("hdd") is False:
       					for name in os.listdir("/media/%s" % directory):                          
						if name.endswith(".nfi"):
        	 	      				name=name.replace(".nfi","")                        
							htmlnfi += "<option value=\"%s/%s.nfi\" class=\"black\">%s</option>\n" % (directory,name,name)
			if os.path.exists("/proc/stb/info/model"):
  				f=open("/proc/stb/info/model")
  				self.boxtype=f.read()
  				f.close()
  				self.boxtype=self.boxtype.replace("\n","").replace("\l","")
			else:
  				f=open("/proc/bus/dreambox")
  				content=f.read()
  				f.close()
				if content.find("7020") is not -1:
  					self.boxtype="dm7020"
				if content.find("600PVR") is not -1:
  					self.boxtype="dm600pvr"
				if content.find("500PLUS") is not -1:
  					self.boxtype="dm500plus"
			name="OpenEmbedded"
			if os.path.exists("/etc/image-version"):
				f=open("/etc/image-version")
	 			line = f.readline()                                                    
        			while (line):                                             
        				line = f.readline()                                                 
        				if line.startswith("creator="):                                    
						name=line
        			f.close()                                                              
				name=name.replace("creator=","")
				sp=[]
				if len(name) > 0:
					sp=name.split(" ")
					if len(sp) > 0:
						name=sp[0]
						name=name.replace("\n","")
			self.creator=name.rstrip().lstrip()
			self.imagetype="exp"
			if name == "OoZooN" and os.path.exists("/etc/issue.net"):
				f=open("/etc/issue.net")
				i=f.read()
				f.close()
				if i.find("xperimental") is -1:
					self.imagetype="rel"
			name=name+"-"+self.imagetype
		 	return """
				<html>
				%s<br>
				<u>%s</u><br><br>
				%s:<br><br>
                                %s<hr>
				%s @ Dreambox<br>
				<form method="GET">
                	       	<select name="file">%s
                                <input type="reset" size="100px"> 
                		<input name="command" type="submit" size=="100px" title=\"%s\" value="%s"> 
				</select>
                               	</form>                             
				<img src="/web-data/img/dflash.png" alt="%s ..."/><br><br>
                               	<hr>
				%s & %s @ Dreambox<br>
				<form method="GET">
 				<input name="directory" type="text" size="40" maxlength="40" value="%s">
 				<input name="file" type="text" size="40" maxlength="40" value="%s-%s-%s-%s">
                                <input type="reset" size="100px"> 
                		<input name="command" type="submit" size=="100px" title=\"%s\" value="%s"> 
				</select>
                               	</form>                             
				<img src="/web-data/img/ring.png" alt="%s ..."/><br><br>
                               	<hr>
    			""" % (header_string,plugin_string,disclaimer_header,disclaimer_wstring,fileupload_string, htmlnfi,flashing_string, "Flashing",flashing_string,backupdirectory_string,backupimage_string,config.plugins.dflash.backuplocation.value,name,self.boxtype,datetime.date.today(),time.strftime("%H-%M"),backup_string,"Backup",backup_string)
		else:
		   if command[0]=="Flashing":
		        # file command is received
			self.nfifile=file[0]
			if os.path.exists(self.nfifile):
		 		if self.nfifile.endswith(".nfi"):
 					f = open(self.nfifile,"r")
	 				header = f.read(32)     
  					f.close()
       					machine_type = header[4:4+header[4:].find("\0")]                        
					if os.path.exists("/proc/stb/info/model"):
						b=open("/proc/stb/info/model","r")
						dreambox=b.read().rstrip("\n")
						b.close()
					else:
  						b=open("/proc/bus/dreambox")
  						content=b.read()
		  				b.close()
						if content.find("7020") is not -1:
  							dreambox="dm7020"
						if content.find("600PVR") is not -1:
  							dreambox="dm600pvr"
						if content.find("500PLUS") is not -1:
  							dreambox="dm500plus"
 					v = open("/usr/lib/opkg/status","r")
 					line = v.readline()     
					found=False
					loaderversion=0
					while (line) and not found:                                                                   
                		        	line = v.readline()                                                
                        			if line.startswith("Package: dreambox-secondstage"):                                            
                           			     	found=True                                                  
	                    			    	line = v.readline()                                                
                                    			line=line.replace("Version: ","")
							loader=line.split("-")
							loaderversion=int(loader[0])
  					v.close()
					print "[dFlash] %s %s %i %s" % (machine_type,dreambox,loaderversion,header[:4])
					if dreambox == "dm7025" or dreambox == "dm7020" or dreambox == "dm500plus":
						print "[dFlash] unsupported"
						return header_string+unsupported_string
					if machine_type.startswith(dreambox) is False and dreambox is not "dm7020":                                        
						print "[dFlash] wrong header"
						return header_string+nonfi_string
					elif (dreambox == "dm800" or dreambox == "dm800se" or dreambox == "dm500hd" or dreambox == "dm7020hd") and loaderversion < 84 and header[:4] == "NFI2":
						print "[dFlash] wrong header"
						return header_string+nonfi_string
					elif (dreambox == "dm800" or dreambox == "dm800se" or dreambox == "dm500hd" or dreambox == "dm7020hd") and loaderversion >= 84 and header[:4] != "NFI2":
						print "[dFlash] wrong header"
						return header_string+nonfi_string
					elif (dreambox == "dm7025" or dreambox == "dm8000") and header[:4] != "NFI1":
						print "[dFlash] wrong header"
						return header_string+nonfi_string
					else:
						print "[dFlash] correct header"
					loaderdev="/dev/mtd/1"
					if os.path.exists("/dev/mtd1"):
						loaderdev="/dev/mtd1"
					os.system("%s/bin/nand_check %s > /tmp/.nandcheck" % (dflash_plugindir,loaderdev))
					f=open("/tmp/.nandcheck")
					bad=0
		                	for line in f.readlines():
						if line.startswith("="):
							print line
							if line.find("B") is not -1:
								bad=1
					f.close()
					if bad:
						print "[dFlash] bad blocks"
						return header_string+badblocks_string % loaderdev

					CreateScript()
					if (eDVBVolumecontrol.getInstance().isMuted()) is False:
						eDVBVolumecontrol.getInstance().volumeToggleMute()
					self.avswitch = AVSwitch()
					if SystemInfo["ScartSwitch"]:
						self.avswitch.setInput("SCART")
					else:
						self.avswitch.setInput("AUX")
					print "[dFlash] is flashing now %s" % self.nfifile
    					os.system("start-stop-daemon -S -b -x %s \"%s\"" % (dflash_script,self.nfifile))
					self.FlashTimer = eTimer()
     			 		self.FlashTimer.stop()
     				   	self.FlashTimer.timeout.get().append(self.secondFlash)
 				       	self.FlashTimer.start(60000,True)
					return dflash_flashing
				else:
					print "[dFlash] wrong filename"
 					return header_string+nonfi_string
		 	else:
				print "[dFlash] filename not found"
 				return header_string+nonfi_string

		   elif command[0]=="Backup":
			self.backupname=file[0].replace(" ","").replace("[","").replace("]","").replace(">","").replace("<","").replace("|","").rstrip().lstrip()
			path=directory[0]
			sp=[]
			sp=path.split("/")
			print sp
			if len(sp) > 1:
				if sp[1] != "media":
					return header_string+" "+mounted_string % path +", "+dflash_backbutton
			mounted=False
		      	# check if swapfile too small
		        fm=open("/proc/meminfo")                                                
       	        	line = fm.readline()                                                    
       	         	swapspace=0                                                                  
                 	while (line):                                             
           	    		line = fm.readline()                                                 
           	    		if line.startswith("SwapTotal:"):                                    
              				swapspace=int(line.replace("SwapTotal: ","").replace("kB",""))/1000             
                    	fm.close()                                                              
	         	print "[dFlash] swapspace: %i MB" % swapspace
		 	self.ownswap=True
	         	if swapspace < config.plugins.dflash.swapsize.value: 
		 		self.ownswap=False
			self.swappable=False
			sp2=[]
                	f=open("/proc/mounts", "r")
       		 	m = f.readline()                                                    
        		while (m) and not mounted:                                             
				if m.find("/%s/%s" % (sp[1],sp[2])) is not -1:
					mounted=True
					print m
					sp2=m.split(" ")
					print sp2
					if sp2[2].startswith("ext") or sp2[2].endswith("fat"):
						print "[dFlash] swappable"
						self.swappable=True
           			m = f.readline()                                                 
			f.close()	
			if not mounted:
				return header_string+" "+mounted_string % path +", "+dflash_backbutton
			path=path.lstrip().rstrip().replace(" ","")
	      		config.plugins.dflash.backuplocation.value=path
	      		config.plugins.dflash.backuplocation.save()
		        if not os.path.exists(config.plugins.dflash.backuplocation.value):
		 		os.mkdir(config.plugins.dflash.backuplocation.value,0777)
			if os.path.exists("%s/%s.nfi" % (config.plugins.dflash.backuplocation.value,self.backupname)):
				print "[dFlash] filename already exists"
				return header_string+"%s.nfi" % self.backupname+" "+_("already exists,")+" "+dflash_backbutton
			else:
		 		if self.backupname.endswith(".nfi") or len(self.backupname) < 1:
					print "[dFlash] filename with .nfi"
 					return header_string+nonfi_string+", "+dflash_backbutton
				elif self.backupname.find(" ") is not -1:
					print "[dFlash] filename with blank"
 					return header_string+nonfi_string+", "+dflash_backbutton
				else:
					# backupfile request
                 			BackupImage(False,self.backupname,self.imagetype,self.creator,self.swappable,self.ownswap)
					return header_string+dflash_backuping
		   else:
			print "[dFlash] unknown command"
              		return header_string+_("nothing entered")                 

	def secondFlash(self):
		print "[dFlash] second flashing now %s" % self.nfifile
 		os.system("%s \"%s\" &" % (dflash_script,self.nfifile))

class CreateScript:
	if os.path.exists("/proc/stb/info/model"):
		b=open("/proc/stb/info/model","r")
		dreambox=b.read().rstrip("\n")
		b.close()
	else:
		b=open("/proc/bus/dreambox")
		content=b.read()
		b.close()
		if content.find("7020") is not -1:
			dreambox="dm7020"
		if content.find("600PVR") is not -1:
			dreambox="dm600pvr"
		if content.find("500PLUS") is not -1:
			dreambox="dm500plus"
	f=open(dflash_script,"w")
	f.write("#!/bin/sh -x\n")
   	f.write("sleep 1\n")
	if dreambox.startswith("dm500hd"):
		f.write("echo FFFFFFFF > /proc/stb/fp/led0_pattern\n") 
	elif dreambox.startswith("dm500plus") or dreambox.startswith("dm600"):
		f.write("echo 0 > /proc/tRNA/led/ledrd\n") 
		f.write("echo 1 > /proc/tRNA/led/ledgr\n") 
	else:
		f.write("echo 20 > /proc/progress\n")
	if config.plugins.dflash.ramfs.value:
		f.write("mkdir /var/ramfs\n")
		f.write("mount -t ramfs ramfs /var/ramfs\n")
		f.write("cp \"$1\" /var/ramfs/flash.nfi\n")
	if config.plugins.dflash.flashtool.value == "writenfi":
		f.write("cp %s/writenfi /var/writenfi\n" % dflash_bin)
		f.write("chmod 755 /var/writenfi\n")
	elif config.plugins.dflash.flashtool.value == "nandwrite":
		f.write("gunzip -c %s/nfidump.gz > /var/nfidump\n" % dflash_bin)
		f.write("chmod 755 /var/nfidump\n")
		f.write("cp %s/nandwrite /var/nandwrite\n" % dflash_bin)
		f.write("chmod 755 /var/nandwrite\n")
		f.write("cp /sbin/reboot /var/reboot\n" % dflash_bin)
		f.write("chmod 755 /var/reboot\n")
		f.write("/var/reboot xxx\n")
	else:
		f.write("gunzip -c %s/nfidump.gz > /var/nfidump\n" % dflash_bin)
		f.write("chmod 755 /var/nfidump\n")
	if dreambox.startswith("dm7025"):
		if os.path.exists("/dev/mtdblock/2"):
			f.write("ln -sfn /dev/mtdblock/2 /dev/root\n")
		else:
			f.write("ln -sfn /dev/mtdblock2 /dev/root\n")
	else:
		if os.path.exists("/dev/mtdblock/3"):
			f.write("ln -sfn /dev/mtdblock/3 /dev/root\n")
		else:
			f.write("ln -sfn /dev/mtdblock3 /dev/root\n")
	if os.path.exists("/dev/mtd/0"):
		f.write("chmod 777 /dev/mtd/0\n")
	else:
		f.write("chmod 777 /dev/mtd0\n")
   	f.write("killall -9 enigma2\n")
	f.write("init 1\n")
	if dreambox.startswith("dm500hd"):
		f.write("echo 00000000 > /proc/stb/fp/led0_pattern\n") 
		f.write("echo 00000000 > /proc/stb/fp/led1_pattern\n") 
	elif dreambox.startswith("dm500plus") or dreambox.startswith("dm600"):
		f.write("echo 2 > /proc/tRNA/led/ledgr\n") 
	else:
		f.write("echo 40 > /proc/progress\n")
	f.write("sleep 8\n")
	if dreambox.startswith("dm500hd"):
		f.write("echo FFFFFFFF > /proc/stb/fp/led0_pattern\n") 
	elif dreambox.startswith("dm500plus") or dreambox.startswith("dm600"):
		f.write("echo 0 > /proc/tRNA/led/ledgr\n") 
		f.write("echo 2 > /proc/tRNA/led/ledrd\n") 
	else:
		f.write("echo 60 > /proc/progress\n")
	f.write("sync\n")
	if config.plugins.dflash.flashtool.value == "writenfi":
		if dreambox.startswith("dm7025"):
			f.write("mount -no remount,ro /boot/mnt/flash\n")
		else:
			f.write("mount -no remount,ro /dev/root  /\n")
		if config.plugins.dflash.ramfs.value:
			f.write("/var/writenfi /var/ramfs/flash.nfi -reboot\n")
		else:
			f.write("/var/writenfi \"$1\" -reboot\n")
	elif config.plugins.dflash.flashtool.value == "nandwrite":
		f.write("umount /boot\n")
		if config.plugins.dflash.ramfs.value:
			f.write("/var/nfidump --j /var/ramfs/flash.nfi /tmp/root\n")
		else:
			f.write("/var/nfidump --j \"$1\" /tmp/root\n")
		f.write("/var/nandwrite -m /dev/mtd2 /tmp/root/boot.jffs2\n")
		if dreambox.startswith("dm7025"):
			f.write("mount -no remount,ro /boot/mnt/flash\n")
		else:
			f.write("mount -no remount,ro /dev/root  /\n")
		f.write("/var/nandwrite -m /dev/mtd3 /tmp/root/root.jffs2\n")
		f.write("/var/reboot -f -n -d\n")
	else:
		f.write("mkdir /tmp/root\n")
		f.write("mount -no remount,rw /boot\n")
		if dreambox.startswith("dm7025"):
			f.write("mount -t jffs2 /dev/mtdblock/3 /tmp/root\n")
			f.write("mkdir /tmp/root/boot\n")
			f.write("mount -t jffs2 /dev/mtdblock/2 /tmp/root/boot\n")
		else:
			f.write("mount -t jffs2 /dev/mtdblock3 /tmp/root\n")
			f.write("mkdir /tmp/root/boot\n")
			f.write("mount -t jffs2 /dev/mtdblock2 /tmp/root/boot\n")
		f.write("mount -o remount,size=128M /tmp\n")
		f.write("mount -o remount,size=32M /var\n")
		if config.plugins.dflash.overwrite.value:
			if config.plugins.dflash.ramfs.value:
				f.write("/var/nfidump --overwrite --temp --squashfs --reboot /var/ramfs/flash.nfi /tmp/root\n")
			else:
				f.write("/var/nfidump --overwrite --temp --squashfs --reboot \"$1\" /tmp/root\n")
		else:
			if config.plugins.dflash.ramfs.value:
				f.write("/var/nfidump --squashfs --reboot /var/ramfs/flash.nfi /tmp/root\n")
			else:
				f.write("/var/nfidump --squashfs --reboot \"$1\" /tmp/root\n")
	if dreambox.startswith("dm500hd"):
		f.write("echo 00000000 > /proc/stb/fp/led0_pattern\n") 
		f.write("echo FFFFFFFF > /proc/stb/fp/led1_pattern\n") 
	elif dreambox.startswith("dm500plus") or dreambox.startswith("dm600"):
		f.write("echo 0 > /proc/tRNA/led/ledrd\n") 
		f.write("echo 1 > /proc/tRNA/led/ledgr\n") 
	else:
		f.write("echo 100 > /proc/progress\n")
	f.write("init 3\n")
	f.write("exit 0\n")
	f.close()
	os.system("chmod 755 %s" % dflash_script)
	print "[dFlash] %s created" % dflash_script

class BackupImage(Screen):                                                      
        def __init__(self,session,backupname,imagetype,creator,swappable,ownswap):            
        	print "[dFlash] does backup"
		os.system("touch %s" % dflash_busy)
        	self.session=session    
        	self.backupname=backupname               
        	self.imagetype=imagetype                                        
        	self.creator=creator                 
        	self.swappable=swappable                 
        	self.ownswap=ownswap                
		if os.path.exists("/proc/stb/info/model"):
			f=open("/proc/stb/info/model")
			self.boxtype=f.read()
			f.close()
			self.boxtype=self.boxtype.replace("\n","").replace("\l","")
		else:
			f=open("/proc/bus/dreambox")
			content=f.read()
			f.close()
			if content.find("7020") is not -1:
				self.boxtype="dm7020"
			if content.find("600PVR") is not -1:
				self.boxtype="dm600pvr"
			if content.find("500PLUS") is not -1:
				self.boxtype="dm500plus"
		print "[dFlash] boxtype %s" % self.boxtype
		if os.path.exists("%s/r.jffs2" % config.plugins.dflash.backuplocation.value):
			os.remove("%s/r.jffs2" % config.plugins.dflash.backuplocation.value)
		if os.path.exists("%s/b.jffs2" % config.plugins.dflash.backuplocation.value):
			os.remove("%s/b.jffs2" % config.plugins.dflash.backuplocation.value)
		if os.path.exists("%s/s.bin" % config.plugins.dflash.backuplocation.value):
			os.remove("%s/s.bin" % config.plugins.dflash.backuplocation.value)
		if self.boxtype == "dm8000":
 			os.system("df > /tmp/.df")
 			f=open("/tmp/.df")
 			i=f.readline()
 			i=f.readline()
 			f.close()
 			if i.find("61440") is not -1:
				self.buildoptions="%s/buildimage -a dm8000 -e 0x20000 -f 0x4000000 -s 2048 -b 0x100000:%s/s.bin -d 0x300000:%s/b.jffs2 -d 0x3C00000:%s/r.jffs2 > %s/%s.nfi\n"
			else:
				self.buildoptions="%s/buildimage -a dm8000 -e 0x20000 -f 0x10000000 -s 2048 -b 0x100000:%s/s.bin -d 0x700000:%s/b.jffs2 -d 0xF800000:%s/r.jffs2 > %s/%s.nfi\n"
			self.jffs2options=" -e 0x20000 -n -l"
		elif self.boxtype == "dm7020hd":
			self.buildoptions="%s/buildimage --brcmnand -a dm7020hd -e 0x40000 -f 0x10000000 -s 4096 -b 0x100000:%s/s.bin -d 0x700000:%s/b.jffs2 -d 0xF800000:%s/r.jffs2 > %s/%s.nfi\n"
			self.jffs2options=" -e 0x40000 -n -l"
		elif self.boxtype == "dm500hd":
			self.buildoptions="%s/buildimage --brcmnand -a dm500hd -e 0x4000 -f 0x4000000 -s 512 -b 0x40000:%s/s.bin -d 0x3C0000:%s/b.jffs2 -d 0x3C00000:%s/r.jffs2 > %s/%s.nfi\n"
			self.jffs2options=" -e 0x4000 -n -l"
		elif self.boxtype == "dm800se":
			self.buildoptions="%s/buildimage --brcmnand -a dm800se -e 0x4000 -f 0x4000000 -s 512 -b 0x40000:%s/s.bin -d 0x3C0000:%s/b.jffs2 -d 0x3C00000:%s/r.jffs2 > %s/%s.nfi\n"
			self.jffs2options=" -e 0x4000 -n -l"
		elif self.boxtype == "dm7020":
			self.buildoptions="%s/buildimage -e 0x4000 -f 0x2000000 -s 512 -b 0x40000:%s/s.bin -d 0x3C0000:%s/b.jffs2 -d 0x1C00000:%s/r.jffs2 > %s/%s.nfi\n"
			self.jffs2options=" -e 0x4000 -n -b"
		elif self.boxtype == "dm600pvr":
			self.buildoptions="%s/buildimage -a dm600pvr -e 0x4000 -f 0x2000000 -s 512 -b 0x40000:%s/s.bin -d 0x3C0000:%s/b.jffs2 -d 0x1C00000:%s/r.jffs2 > %s/%s.nfi\n"
			self.jffs2options=" -e 0x4000 -n -b"
		elif self.boxtype == "dm500plus":
			self.buildoptions="%s/buildimage -a dm500plus -e 0x4000 -f 0x2000000 -s 512 -b 0x40000:%s/s.bin -d 0x3C0000:%s/b.jffs2 -d 0x1C00000:%s/r.jffs2 > %s/%s.nfi\n"
			self.jffs2options=" -e 0x4000 -n -b"
		elif self.boxtype == "dm7025":
			self.buildoptions="%s/buildimage -a dm7025 -e 0x4000 -f 0x2000000 -s 512 -b 0x40000:%s/s.bin -d 0x3C0000:%s/b.jffs2 -d 0x1C00000:%s/r.jffs2 > %s/%s.nfi\n"
			self.jffs2options=" -e 0x4000 -n -l"
		else:   # should be 800hd then
			self.buildoptions="%s/buildimage --brcmnand -a dm800 -e 0x4000 -f 0x4000000 -s 512 -b 0x40000:%s/s.bin -d 0x3C0000:%s/b.jffs2 -d 0x3C00000:%s/r.jffs2 > %s/%s.nfi\n"
			self.jffs2options=" -e 0x4000 -n -l"
		v = open("/usr/lib/opkg/status","r")
		line = v.readline()     
		found=False
		loaderversion=0
		while (line) and not found:                                                                   
                       	line = v.readline()                                                
                       	if line.startswith("Package: dreambox-secondstage"):                                            
                               	found=True                                                  
                        	line = v.readline()                                                
                                line=line.replace("Version: ","")
				loader=line.split("-")
				loaderversion=int(loader[0])
		v.close()
		# backup only as NFI2 if the loader is already NFI2 capable 
		if (self.boxtype == "dm800" or self.boxtype == "dm800se" or self.boxtype == "dm500hd") and loaderversion < 84:
			self.buildoptions=self.buildoptions.replace("--brcmnand","")
		if os.path.exists("/dev/mtd/1"):
			mtdev="/dev/mtd/1"
		else:
			mtdev="/dev/mtd1"
		command= "#!/bin/sh -x\n"
		command +="df -h\n"
	      	if not self.ownswap and (self.swappable or config.plugins.dflash.loopswap.value): # I do it my way ...
			if config.plugins.dflash.loopswap.value is True:
                		command +="swapoff /dev/loop/0\n"
                		command +="losetup -d /dev/loop/0\n"
			else:
                		command +="swapoff %s/swapfile\n" % config.plugins.dflash.backuplocation.value                        
                	command +="rm %s/swapfile\n" % config.plugins.dflash.backuplocation.value                        
                	command +="dd if=/dev/zero of=%s/swapfile bs=1024 count=%i\n" % (config.plugins.dflash.backuplocation.value,int(config.plugins.dflash.swapsize.value*1024))
                	command +="mkswap %s/swapfile\n" % config.plugins.dflash.backuplocation.value                                
			if config.plugins.dflash.loopswap.value is True:
	                	command +="modprobe loop\n"                                 
	                	command +="losetup /dev/loop/0 %s/swapfile\n" % config.plugins.dflash.backuplocation.value                                
	                	command +="swapon /dev/loop/0\n"                                 
			else:
                		command +="swapon %s/swapfile\n" % config.plugins.dflash.backuplocation.value                                 
		command +="/etc/init.d/openvpn stop\n"
		command +="mount -t jffs2 /dev/mtdblock2 /boot\n"
		command +="%s/nanddump -n -o -b -c -f %s/s.bin %s\n" % (dflash_bin,config.plugins.dflash.backuplocation.value,mtdev)
		if self.boxtype == "dm600pvr" or self.boxtype == "dm500plus" or self.boxtype == "dm7020":
			# dirty way to get rid of trailing garbage ... maybe we fix it later in nanddump
			command +="cp %s/s.bin %s/s.bin.gz\n" % (config.plugins.dflash.backuplocation.value,config.plugins.dflash.backuplocation.value)
			command +="gunzip -c %s/s.bin.gz > %s/s.bin\n" % (config.plugins.dflash.backuplocation.value,config.plugins.dflash.backuplocation.value)
			command +="gzip -c %s/s.bin > %s/s.bin.gz\n" % (config.plugins.dflash.backuplocation.value,config.plugins.dflash.backuplocation.value)
			command +="cp %s/s.bin.gz %s/s.bin\n" % (config.plugins.dflash.backuplocation.value,config.plugins.dflash.backuplocation.value)
			command +="rm %s/s.bin.gz\n" % (config.plugins.dflash.backuplocation.value)
		if self.boxtype == "dm7025":
			command +="umount /tmp/boot\n"
			command +="mkdir /tmp/boot\n"
			if os.path.exists("/dev/mtdblock2"):
				command +="mount -t jffs2 /dev/mtdblock2 /tmp/boot\n"
			else:
				command +="mount -t jffs2 /dev/mtdblock/2 /tmp/boot\n"
			command +="%s/mkfs.jffs2 --root=/tmp/boot --faketime --compression-mode=size --output=%s/b.jffs2 %s\n" % (dflash_bin,config.plugins.dflash.backuplocation.value,self.jffs2options)
			command +="umount /tmp/boot\n"
			command +="rmdir /tmp/boot\n"
			if config.plugins.dflash.restart.value is True or (self.swappable is False and self.ownswap is False and config.plugins.dflash.loopswap.value is False):
				command +="wget http://localhost/web/powerstate?newstate=3\n"
				command +="sleep 3\n"
				command +="init 4\n"
			if os.path.exists("/usr/lib/enigma2/python/Plugins/Extensions/LowFAT/flash"):
				command +="%s/mkfs.jffs2 --root=/usr/lib/enigma2/python/Plugins/Extensions/LowFAT/flash --faketime --compression-mode=size --output=%s/r.jffs2 %s\n" % (dflash_bin,config.plugins.dflash.backuplocation.value,self.jffs2options)
			else:
				command +="%s/mkfs.jffs2 --root=/boot/mnt/flash --faketime --compression-mode=size --output=%s/r.jffs2 %s\n" % (dflash_bin,config.plugins.dflash.backuplocation.value,self.jffs2options)
		else:
               		f=open("/proc/mounts", "r")
			self.ignore="--ignore=/media/net --ignore=/autofs  --ignore=/media/swap --ignore=/dev/bus "
			sp=[]
	 		line = f.readline()                                                    
        		while (line):                                             
				sp=line.split(" ")
				if len(sp) > 0:
					if len(sp[1]) > 1 and sp[1] != "/dev":
						print sp[1]
						self.ignore=self.ignore+" --ignore=%s" % sp[1]
        			line = f.readline()                                                 
        		f.close()                                                              
			if not config.plugins.dflash.usr.value:
				self.ignore=self.ignore.replace("--ignore=/usr","")
			command +="%s/mkfs.jffs2 --root=/boot --faketime --compression-mode=size %s --output=%s/b.jffs2 %s\n" % (dflash_bin,self.ignore,config.plugins.dflash.backuplocation.value,self.jffs2options)
			if config.plugins.dflash.summary.value is True:
				command +="%s/sumtool --input=%s/b.jffs2 --output=%s/bs.jffs2 %s\n" % (dflash_bin,config.plugins.dflash.backuplocation.value,config.plugins.dflash.backuplocation.value,self.jffs2options)
				command +="cp %s/bs.jffs2 %s/b.jffs2\n" % (config.plugins.dflash.backuplocation.value,config.plugins.dflash.backuplocation.value)
				command +="rm %s/bs.jffs2\n" % (config.plugins.dflash.backuplocation.value)
			command +="umount /tmp/root/dev\n"
			command +="umount /tmp/root\n"
			command +="mkdir /tmp/root\n"
			command +="mount -o bind / /tmp/root\n"
			if config.plugins.dflash.restart.value is True or (self.swappable is False and self.ownswap is False and config.plugins.dflash.loopswap.value is False):
				command +="wget http://localhost/web/powerstate?newstate=3\n"
				command +="sleep 3\n"
				command +="init 4\n"
			command +="%s/mkfs.jffs2 --root=/tmp/root --faketime --compression-mode=size %s --output=%s/r.jffs2 %s\n" % (dflash_bin,self.ignore,config.plugins.dflash.backuplocation.value,self.jffs2options)
			if config.plugins.dflash.summary.value is True:
				command +="%s/sumtool --input=%s/r.jffs2 --output=%s/rs.jffs2 %s\n" % (dflash_bin,config.plugins.dflash.backuplocation.value,config.plugins.dflash.backuplocation.value,self.jffs2options)
				command +="cp %s/rs.jffs2 %s/r.jffs2\n" % (config.plugins.dflash.backuplocation.value,config.plugins.dflash.backuplocation.value)
				command +="rm %s/rs.jffs2\n" % (config.plugins.dflash.backuplocation.value)
			command +="umount /tmp/root/dev\n"
			command +="umount /tmp/root\n"
			command +="rmdir /tmp/root\n"
		command +="/etc/init.d/openvpn start\n"
		command +="chmod 777 %s/s.bin\n" % config.plugins.dflash.backuplocation.value
		command +="chmod 777 %s/b.jffs2\n" % config.plugins.dflash.backuplocation.value
		command +="chmod 777 %s/r.jffs2\n" % config.plugins.dflash.backuplocation.value
		command +=self.buildoptions % (dflash_bin,config.plugins.dflash.backuplocation.value,config.plugins.dflash.backuplocation.value,config.plugins.dflash.backuplocation.value,config.plugins.dflash.backuplocation.value,self.backupname)
		if not config.plugins.dflash.keep.value:
			command +="rm %s/s.bin\n" % config.plugins.dflash.backuplocation.value
			command +="rm %s/b.jffs2\n" % config.plugins.dflash.backuplocation.value
			command +="rm %s/r.jffs2\n" % config.plugins.dflash.backuplocation.value
		command +="chmod 777 %s/%s.nfi\n" % (config.plugins.dflash.backuplocation.value,self.backupname)
		if not self.ownswap and not config.plugins.dflash.keep.value:
			if config.plugins.dflash.loopswap.value is True:
                		command +="swapoff /dev/loop/0\n"
                		command +="losetup -d /dev/loop/0\n"                        
			else:
                		command +="swapoff %s/swapfile\n" % config.plugins.dflash.backuplocation.value                        
                	command +="rm %s/swapfile\n" % config.plugins.dflash.backuplocation.value                        
		if config.plugins.dflash.restart.value is True or (self.swappable is False and self.ownswap is False):
			command +="init 3\n"
		command +="du -h %s/%s.nfi > %s\n" % (config.plugins.dflash.backuplocation.value,self.backupname,dflash_backup)
		nfo="%s/%s.nfo" % (config.plugins.dflash.backuplocation.value,self.backupname)
		if self.imagetype == "exp":
			command +="echo \"Enigma2: experimental\" > %s\n" % (nfo)
		else:
			command +="echo \"Enigma2: release\" > %s\n" % (nfo)
		command +="echo \"Machine: Dreambox %s\" >> %s\n" % (self.boxtype,nfo)
		command +="echo \"Date: %s\" >> %s\n" % (datetime.date.today(),nfo)
                command +="echo \"Issuer: %s\" >> %s\n" % (self.creator,nfo)
	        command +="echo \"Feed: local\" >> %s\n" % nfo
                command +="echo \"Image: local\" >> %s\n" %nfo
		command +="MD5SUM=`md5sum %s/%s.nfi | cut -d\" \" -f 1`\n" % (config.plugins.dflash.backuplocation.value,self.backupname)
		command +="echo \"MD5: $MD5SUM\" >> %s\n" % nfo
		command +="echo >> %s\n" % nfo
		command +="chmod 777 %s/%s.nfo\n" % (config.plugins.dflash.backuplocation.value,self.backupname)
		command +="ls -alh %s/%s.*\n" % (config.plugins.dflash.backuplocation.value,self.backupname)
		command +="rm %s\n" % dflash_busy
		command +="df -h\n"
		command +="exit 0\n"
		print command
		b=open(dflash_backupscript,"w")
		b.write(command)
		b.close()
		os_chmod(dflash_backupscript, 0777)
		if config.plugins.dflash.synchronous.value:
			os.system(command)
			self.backupDone(True)
		else:
			# here comes my ONE and ONLY container
			self.container = eConsoleAppContainer()
      			self.container.appClosed.append(self.backupDone)
              		self.container.execute("%s > %s 2>&1" % (dflash_backupscript,dflash_backuplog))

        def backupDone(self,status):
		global dflash_busy
		if os.path.exists(dflash_busy):
			os.remove(dflash_busy)
		if os.path.exists(dflash_backup):
			os.remove(dflash_backup)
		if os.path.exists(dflash_backupscript) and not config.plugins.dflash.keep.value:
			os.remove(dflash_backupscript)
		if self.session:
			size=0
			if os.path.exists("%s/%s.nfi" % (config.plugins.dflash.backuplocation.value,self.backupname)):
				size=os.path.getsize("%s/%s.nfi" % (config.plugins.dflash.backuplocation.value,self.backupname))
      			self.session.open(MessageBox,"%i MB " % int(size/1024/1024)+_("Flash Backup to %s finished with imagename:\n\n%s.nfi") % (config.plugins.dflash.backuplocation.value,self.backupname),  MessageBox.TYPE_INFO)                 

###############################################################################
# dFlash Check by gutemine
###############################################################################

class dFlashChecking(Screen):
    skin = """
        <screen position="center,center" size="530,300" title="choose NAND Flash Check" >
        <widget name="menu" position="10,10" size="520,290" scrollbarMode="showOnDemand" />
	<widget name="buttonred" position="10,250" size="120,40" backgroundColor="red" valign="center" halign="center" zPosition="2"  foregroundColor="white" font="Regular;18"/>
	<widget name="buttongreen" position="140,250" size="120,40" backgroundColor="green" valign="center" halign="center" zPosition="2"  foregroundColor="white" font="Regular;18"/>
	<widget name="buttonyellow" position="270,250" size="120,40" backgroundColor="yellow" valign="center" halign="center" zPosition="2"  foregroundColor="white" font="Regular;18"/>
	<widget name="buttonblue" position="400,250" size="120,40" backgroundColor="blue" valign="center" halign="center" zPosition="2"  foregroundColor="white" font="Regular;18"/>
        </screen>"""
        
    def __init__(self, session, args = 0):
        self.skin = dFlashChecking.skin
        self.session = session
        Screen.__init__(self, session)
        self.menu = args
        self.onShown.append(self.setWindowTitle)
        flashchecklist = []
	self["buttonred"] = Label(_("Cancel"))
	self["buttonyellow"] = Label(_("Info"))
	self["buttongreen"] = Label(_("OK"))
	self["buttonblue"] = Label(_("About"))
        if os.path.exists("/dev/mtd0") is True:
        	flashchecklist.append((_("check /dev/mtd0 = entire Flash"), "/dev/mtd0"))
        else:
        	flashchecklist.append((_("check /dev/mtd/0 = entire Flash"), "/dev/mtd/0"))
        if os.path.exists("/dev/mtd1") is True:
        	flashchecklist.append((_("check /dev/mtd1 = secondstage loader"), "/dev/mtd1"))
        else:
        	flashchecklist.append((_("check /dev/mtd/1 = secondstage loader"), "/dev/mtd/1"))
        if os.path.exists("/dev/mtd2") is True:
        	flashchecklist.append((_("check /dev/mtd2 = boot"), "/dev/mtd2"))
        else:
        	flashchecklist.append((_("check /dev/mtd/2 = boot"), "/dev/mtd/2"))
        if os.path.exists("/dev/mtd3") is True:
	        flashchecklist.append((_("check /dev/mtd3 = root"), "/dev/mtd3"))
        else:
	        flashchecklist.append((_("check /dev/mtd/3 = root"), "/dev/mtd/3"))
        if os.path.exists("/dev/mtd4") is True:
           flashchecklist.append((_("check /dev/mtd4 = home"), "/dev/mtd4"))
        if os.path.exists("/dev/mtd/4") is True:
           flashchecklist.append((_("check /dev/mtd/4 = home"), "/dev/mtd/4"))
        if os.path.exists("/dev/mtd5") is True:
           flashchecklist.append((_("check /dev/mtd5 = unused"), "/dev/mtd5"))
        if os.path.exists("/dev/mtd/5") is True:
           flashchecklist.append((_("check /dev/mtd/5 = unused"), "/dev/mtd/5"))
        if os.path.exists("/dev/mtd6") is True:
           flashchecklist.append((_("check /dev/mtd6 = unused"), "/dev/mtd6"))
        if os.path.exists("/dev/mtd/6") is True:
           flashchecklist.append((_("check /dev/mtd/6 = unused"), "/dev/mtd/6"))
        self["menu"] = MenuList(flashchecklist)
	self["setupActions"] = ActionMap([ "ColorActions", "SetupActions" ],
		{
		"ok": self.go,
		"green": self.go,
		"red": self.close,
		"yellow": self.legend,
		"blue": self.about,
		"cancel": self.close,
		})
        
    def go(self):
        returnValue = self["menu"].l.getCurrentSelection()[1]
        if returnValue is not None:
        	self.session.open(Console,_("checking %s - be patient (up to 1 min)" % returnValue),["%s/bin/nand_check %s\n" % (dflash_plugindir,returnValue) ])

    def setWindowTitle(self):
	self.setTitle(flashing_string+" & "+backup_string+" V%s " % dflash_version + checking_string)

    def legend(self):
        title=_("B Bad block\n. Empty block\n- Partially filled block\n= Full block, no summary node\nS Full block, summary node\nIgnore B at the end of Flash")
        self.session.open(MessageBox, title,  MessageBox.TYPE_INFO)

    def about(self):
       	self.session.open(dFlashAbout)

class dFlashConfiguration(Screen, ConfigListScreen):
    skin = """
        <screen position="center,center" size="610,400" title="dFlash Configuration" >
        <widget name="config" position="0,0" size="610,400" scrollbarMode="showOnDemand" />
        <widget name="buttonred" position="10,350" size="140,40" backgroundColor="red" valign="center" halign="center" zPosition="2"  foregroundColor="white" font="Regular;14"/>
        <widget name="buttongreen" position="160,350" size="140,40" backgroundColor="green" valign="center" halign="center" zPosition="2"  foregroundColor="white" font="Regular;14"/>
        <widget name="buttonyellow" position="310,350" size="140,40" backgroundColor="yellow" valign="center" halign="center" zPosition="2"  foregroundColor="white" font="Regular;14"/>
        <widget name="buttonblue" position="460,350" size="140,40" backgroundColor="blue" valign="center" halign="center" zPosition="2"  foregroundColor="white" font="Regular;14"/>
        </screen>"""

    def __init__(self, session, args = 0):
	Screen.__init__(self, session)
	if os.path.exists("/proc/stb/info/model"):
		f=open("/proc/stb/info/model")
		self.boxtype=f.read()
		f.close()
		self.boxtype=self.boxtype.replace("\n","").replace("\l","")
       	self.list = []
        self.list.append(getConfigListEntry(backupdirectory_string, config.plugins.dflash.backuplocation))
        self.list.append(getConfigListEntry(_("Swapsize [MB]"), config.plugins.dflash.swapsize))
       	self.list.append(getConfigListEntry(_("sort alphabetic"), config.plugins.dflash.sort))
	if config.usage.setup_level.value == "expert":
        	self.list.append(getConfigListEntry(_("show in Extensions Menu"), config.plugins.dflash.extension))
        	self.list.append(getConfigListEntry(_("Flashtool"), config.plugins.dflash.flashtool))
		if self.boxtype == "dm7020hd" or self.boxtype =="dm8000":
	        	self.list.append(getConfigListEntry(_("jffs2 erase block summary"), config.plugins.dflash.summary))
        	self.list.append(getConfigListEntry(_("overwrite only image "), config.plugins.dflash.overwrite))
        	self.list.append(getConfigListEntry(_("use ramfs for flashing"), config.plugins.dflash.ramfs))
        	self.list.append(getConfigListEntry(_("loop swap over network"), config.plugins.dflash.loopswap))
        	self.list.append(getConfigListEntry(_("keep temporary files"), config.plugins.dflash.keep))
        	self.list.append(getConfigListEntry(_("restart enigma2"), config.plugins.dflash.restart))
        	self.list.append(getConfigListEntry(_("ignore /usr mount for backup"), config.plugins.dflash.usr))
        	self.list.append(getConfigListEntry(_("synchronous script execution"), config.plugins.dflash.synchronous))

        self.onShown.append(self.setWindowTitle)
       	ConfigListScreen.__init__(self, self.list)

        # explizit check on every entry
	self.onChangedEntry = []

       	self["buttonred"] = Label(_("Cancel"))
       	self["buttongreen"] = Label(_("OK"))
       	self["buttonyellow"] = Label(checking_string)
	self["buttonblue"] = Label(_("Disclaimer"))
        self["setupActions"] = ActionMap(["SetupActions", "ColorActions"],
       	{
       		"green": self.save,
        	"red": self.cancel,
	       	"yellow": self.checking,
        	"blue": self.disclaimer,
            	"save": self.save,
            	"cancel": self.cancel,
            	"ok": self.save,
       	})
    def setWindowTitle(self):
	self.setTitle(flashing_string+" & "+backup_string+" V%s " % dflash_version + setup_string)

    def save(self):
        for x in self["config"].list:
           x[1].save()
        self.close(True)

    def cancel(self):
        for x in self["config"].list:
           x[1].cancel()
        self.close(False)

    def checking(self):      
        self.session.open(dFlashChecking)

    def disclaimer(self):
	self.session.openWithCallback(self.about,MessageBox, disclaimer_string, MessageBox.TYPE_WARNING)

    def about(self,answer):
       	self.session.open(dFlashAbout)

class dFlashAbout(Screen):
    skin = """
        <screen position="center,center" size="600,470" title="About dFlash" >
        <ePixmap position="250,10" size="100,100" pixmap="/usr/lib/enigma2/python/Plugins/Extensions/dFlash/g3icon_dflash.png" transparent="1" alphatest="on" />                                              
        <widget name="aboutdflash" position="10,120" size="600,50" valign="center" halign="center" zPosition="2"  foregroundColor="white" font="Regular;24"/>
        <widget name="buttonred" position="120,420" size="120,40" backgroundColor="red" valign="center" halign="center" zPosition="2"  foregroundColor="white" font="Regular;18"/>
        <widget name="buttongreen" position="360,420" size="120,40" backgroundColor="green" valign="center" halign="center" zPosition="2"  foregroundColor="white" font="Regular;18"/>
        <widget name="freefilesystem" position="100,180" size="180,240" valign="center" halign="center" zPosition="2"  foregroundColor="white" font="Regular;24"/>
        <widget name="freememory" position="330,180" size="180,240" valign="center" halign="center" zPosition="2"  foregroundColor="white" font="Regular;24"/>
        </screen>"""

    def __init__(self, session, args = 0):
	Screen.__init__(self, session)
        self.onShown.append(self.setWindowTitle)

	os.system("df -m > /tmp/out; free >> /tmp/out")
	df=open("/tmp/out")
	line = df.readline()
	sp=[]
	found=False
	while (line) and not found:
       		line = df.readline()
        	if line.endswith("/\n"):
        		found=True
        		while line.find("  ") is not -1:
        			line=line.replace("  "," ")
 	          	sp=line.split(" ")
       	df.close()
 	fm=open("/tmp/out")
      	line = fm.readline()
       	sp2=[]
       	found=False
       	while (line) and not found:
       		line = fm.readline()
       		if line.startswith("Total:"):
       			found=True
       			while line.find("  ") is not -1:
              			line=line.replace("  "," ")
              		line=line.replace("Total: ","")
              		sp2=line.split(" ")
       	fm.close()
       	freefilesystem=_("Root Filesystem\n\ntotal: %s MB\nused:  %s MB\nfree:  %s") % (sp[1],sp[2],sp[3])		
	# dumb bug I know ...
        freefilesystem=freefilesystem+" MB"
      	freememory=_("Memory\n\ntotal: %i MB\nused: %i MB\nfree: %i MB") % (int(sp2[0])/1024,int(sp2[1])/1024,int(sp2[2])/1024)		

       	self["buttonred"] = Label(_("Cancel"))
       	self["buttongreen"] = Label(_("OK"))
       	self["aboutdflash"] = Label(plugin_string)
       	self["freefilesystem"] = Label(freefilesystem)
       	self["freememory"] = Label(freememory)
        self["setupActions"] = ActionMap(["SetupActions", "ColorActions"],
       	{
       		"green": self.cancel,
        	"red": self.cancel,
	       	"yellow": self.cancel,
        	"blue": self.cancel,
            	"save": self.cancel,
            	"cancel": self.cancel,
            	"ok": self.cancel,
       	})
    def setWindowTitle(self):
        self.setTitle( _("About")+" dFlash")

    def cancel(self):
        self.close(False)


